DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Hierarchical Data Structure

Use the following properties to bind the TreeView to hierarchical data:

  • items[]
    Assigns a local array as done in this demo.

  • dataSource
    Assigns a DataSource object that allows you to perform data shaping operations and use a remote source.

Each object in the TreeView's hierarchical data structure should include the following fields:

  • id
    Unique item identifier.

  • text
    Text displayed by the item.

  • items
    Nested objects (optional).

You can respectively use the keyExpr, displayExpr, and itemsExpr properties to specify custom names for the above-mentioned fields. Node objects can also include developer-defined fields and properties from this help section: items[].

In this demo, nodes use the expanded property, which specifies whether a node is collapsed or expanded. They also include the developer-defined price and image fields.

To get started with the DevExtreme TreeView component, refer to the following tutorial for step-by-step instructions: Getting Started with TreeView.

Backend API
$(() => { $('#simple-treeview').dxTreeView({ items: products, width: 300, onItemClick(e) { const item = e.itemData; if (item.price) { $('#product-details').removeClass('hidden'); $('#product-details > img').attr('src', item.image); $('#product-details > .price').text(`$${item.price}`); $('#product-details > .name').text(item.text); } else { $('#product-details').addClass('hidden'); } }, }).dxTreeView('instance'); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.6/css/dx.light.css" /> <script src="js/dx.all.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="form"> <div id="simple-treeview"></div> <div id="product-details" class="hidden"> <img src="" /> <div class="name"></div> <div class="price"></div> </div> </div> </div> </body> </html>
#simple-treeview, #product-details { display: inline-block; } #product-details { vertical-align: top; width: 400px; height: 420px; margin-left: 20px; } #product-details > img { border: none; height: 300px; width: 400px; } #product-details > .name { text-align: center; font-size: 20px; } #product-details > .price { text-align: center; font-size: 24px; } .dark #product-details > div { color: #f0f0f0; } .hidden { visibility: hidden; }
const products = [{ id: '1', text: 'Stores', expanded: true, items: [{ id: '1_1', text: 'Super Mart of the West', expanded: true, items: [{ id: '1_1_1', text: 'Video Players', items: [{ id: '1_1_1_1', text: 'HD Video Player', price: 220, image: '../../../../images/products/1.png', }, { id: '1_1_1_2', text: 'SuperHD Video Player', image: '../../../../images/products/2.png', price: 270, }], }, { id: '1_1_2', text: 'Televisions', expanded: true, items: [{ id: '1_1_2_1', text: 'SuperLCD 42', image: '../../../../images/products/7.png', price: 1200, }, { id: '1_1_2_2', text: 'SuperLED 42', image: '../../../../images/products/5.png', price: 1450, }, { id: '1_1_2_3', text: 'SuperLED 50', image: '../../../../images/products/4.png', price: 1600, }, { id: '1_1_2_4', text: 'SuperLCD 55', image: '../../../../images/products/6.png', price: 1350, }, { id: '1_1_2_5', text: 'SuperLCD 70', image: '../../../../images/products/9.png', price: 4000, }], }, { id: '1_1_3', text: 'Monitors', expanded: true, items: [{ id: '1_1_3_1', text: '19"', expanded: true, items: [{ id: '1_1_3_1_1', text: 'DesktopLCD 19', image: '../../../../images/products/10.png', price: 160, }], }, { id: '1_1_3_2', text: '21"', items: [{ id: '1_1_3_2_1', text: 'DesktopLCD 21', image: '../../../../images/products/12.png', price: 170, }, { id: '1_1_3_2_2', text: 'DesktopLED 21', image: '../../../../images/products/13.png', price: 175, }], }], }, { id: '1_1_4', text: 'Projectors', items: [{ id: '1_1_4_1', text: 'Projector Plus', image: '../../../../images/products/14.png', price: 550, }, { id: '1_1_4_2', text: 'Projector PlusHD', image: '../../../../images/products/15.png', price: 750, }], }], }, { id: '1_2', text: 'Braeburn', items: [{ id: '1_2_1', text: 'Video Players', items: [{ id: '1_2_1_1', text: 'HD Video Player', image: '../../../../images/products/1.png', price: 240, }, { id: '1_2_1_2', text: 'SuperHD Video Player', image: '../../../../images/products/2.png', price: 300, }], }, { id: '1_2_2', text: 'Televisions', items: [{ id: '1_2_2_1', text: 'SuperPlasma 50', image: '../../../../images/products/3.png', price: 1800, }, { id: '1_2_2_2', text: 'SuperPlasma 65', image: '../../../../images/products/8.png', price: 3500, }], }, { id: '1_2_3', text: 'Monitors', items: [{ id: '1_2_3_1', text: '19"', items: [{ id: '1_2_3_1_1', text: 'DesktopLCD 19', image: '../../../../images/products/10.png', price: 170, }], }, { id: '1_2_3_2', text: '21"', items: [{ id: '1_2_3_2_1', text: 'DesktopLCD 21', image: '../../../../images/products/12.png', price: 180, }, { id: '1_2_3_2_2', text: 'DesktopLED 21', image: '../../../../images/products/13.png', price: 190, }], }], }], }, { id: '1_3', text: 'E-Mart', items: [{ id: '1_3_1', text: 'Video Players', items: [{ id: '1_3_1_1', text: 'HD Video Player', image: '../../../../images/products/1.png', price: 220, }, { id: '1_3_1_2', text: 'SuperHD Video Player', image: '../../../../images/products/2.png', price: 275, }], }, { id: '1_3_3', text: 'Monitors', items: [{ id: '1_3_3_1', text: '19"', items: [{ id: '1_3_3_1_1', text: 'DesktopLCD 19', image: '../../../../images/products/10.png', price: 165, }], }, { id: '1_3_3_2', text: '21"', items: [{ id: '1_3_3_2_1', text: 'DesktopLCD 21', image: '../../../../images/products/12.png', price: 175, }], }], }], }, { id: '1_4', text: 'Walters', items: [{ id: '1_4_1', text: 'Video Players', items: [{ id: '1_4_1_1', text: 'HD Video Player', image: '../../../../images/products/1.png', price: 210, }, { id: '1_4_1_2', text: 'SuperHD Video Player', image: '../../../../images/products/2.png', price: 250, }], }, { id: '1_4_2', text: 'Televisions', items: [{ id: '1_4_2_1', text: 'SuperLCD 42', image: '../../../../images/products/7.png', price: 1100, }, { id: '1_4_2_2', text: 'SuperLED 42', image: '../../../../images/products/5.png', price: 1400, }, { id: '1_4_2_3', text: 'SuperLED 50', image: '../../../../images/products/4.png', price: 1500, }, { id: '1_4_2_4', text: 'SuperLCD 55', image: '../../../../images/products/6.png', price: 1300, }, { id: '1_4_2_5', text: 'SuperLCD 70', image: '../../../../images/products/9.png', price: 4000, }, { id: '1_4_2_6', text: 'SuperPlasma 50', image: '../../../../images/products/3.png', price: 1700, }], }, { id: '1_4_3', text: 'Monitors', items: [{ id: '1_4_3_1', text: '19"', items: [{ id: '1_4_3_1_1', text: 'DesktopLCD 19', image: '../../../../images/products/10.png', price: 160, }], }, { id: '1_4_3_2', text: '21"', items: [{ id: '1_4_3_2_1', text: 'DesktopLCD 21', image: '../../../../images/products/12.png', price: 170, }, { id: '1_4_3_2_2', text: 'DesktopLED 21', image: '../../../../images/products/13.png', price: 180, }], }], }, { id: '1_4_4', text: 'Projectors', items: [{ id: '1_4_4_1', text: 'Projector Plus', image: '../../../../images/products/14.png', price: 550, }, { id: '1_4_4_2', text: 'Projector PlusHD', image: '../../../../images/products/15.png', price: 750, }], }], }], }];

If you have technical questions, please create a support ticket in the DevExpress Support Center.
import React, { useCallback, useState } from 'react';
import TreeView, { TreeViewTypes } from 'devextreme-react/tree-view';
import service, { ProductType } from './data.ts';
const products = service.getProducts();
const App = () => {
const [currentItem, setCurrentItem] = useState({ products[0] });
const selectItem = useCallback((e: TreeViewTypes.ItemClickEvent & { itemData?: ProductType; }) => {
setCurrentItem({ e.itemData });
}, [setCurrentItem]);
return (
<div className="form">
<TreeView id="simple-treeview"
items={products}
width={300}
onItemClick={selectItem} />
{currentItem.price
&& <div id="product-details">
<img src={currentItem.image} />
<div className="name">{currentItem.text}</div>
<div className="price">{`$${currentItem.price}`}</div>
</div>
}
</div>
);
};
export default App;
xxxxxxxxxx
import React, { useCallback, useState } from 'react';
import TreeView from 'devextreme-react/tree-view';
import service from './data.js';
const products = service.getProducts();
const App = () => {
const [currentItem, setCurrentItem] = useState({ products[0] });
const selectItem = useCallback(
(e) => {
setCurrentItem({ e.itemData });
},
[setCurrentItem],
);
return (
<div className="form">
<TreeView
id="simple-treeview"
items={products}
width={300}
onItemClick={selectItem}
/>
{currentItem.price && (
<div id="product-details">
<img src={currentItem.image} />
<div className="name">{currentItem.text}</div>
<div className="price">{`$${currentItem.price}`}</div>
</div>
)}
</div>
);
};
export default App;
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
xxxxxxxxxx
const products = [{
id: '1',
text: 'Stores',
expanded: true,
items: [{
id: '1_1',
text: 'Super Mart of the West',
expanded: true,
items: [{
id: '1_1_1',
text: 'Video Players',
items: [{
id: '1_1_1_1',
text: 'HD Video Player',
price: 220,
image: 'images/products/1.png',
}, {
id: '1_1_1_2',
text: 'SuperHD Video Player',
image: 'images/products/2.png',
price: 270,
}],
}, {
id: '1_1_2',
text: 'Televisions',
expanded: true,
items: [{
id: '1_1_2_1',
text: 'SuperLCD 42',
image: 'images/products/7.png',
price: 1200,
}, {
id: '1_1_2_2',
text: 'SuperLED 42',
image: 'images/products/5.png',
price: 1450,
}, {
id: '1_1_2_3',
text: 'SuperLED 50',
image: 'images/products/4.png',
price: 1600,
}, {
id: '1_1_2_4',
text: 'SuperLCD 55',
image: 'images/products/6.png',
price: 1350,
}, {
id: '1_1_2_5',
text: 'SuperLCD 70',
image: 'images/products/9.png',
price: 4000,
}],
}, {
id: '1_1_3',
text: 'Monitors',
expanded: true,
items: [{
id: '1_1_3_1',
text: '19"',
expanded: true,
items: [{
id: '1_1_3_1_1',
text: 'DesktopLCD 19',
image: 'images/products/10.png',
price: 160,
}],
}, {
id: '1_1_3_2',
text: '21"',
items: [{
id: '1_1_3_2_1',
text: 'DesktopLCD 21',
image: 'images/products/12.png',
price: 170,
}, {
id: '1_1_3_2_2',
text: 'DesktopLED 21',
image: 'images/products/13.png',
price: 175,
}],
}],
}, {
id: '1_1_4',
text: 'Projectors',
items: [{
id: '1_1_4_1',
text: 'Projector Plus',
image: 'images/products/14.png',
price: 550,
}, {
id: '1_1_4_2',
text: 'Projector PlusHD',
image: 'images/products/15.png',
price: 750,
}],
}],
}, {
id: '1_2',
text: 'Braeburn',
items: [{
id: '1_2_1',
text: 'Video Players',
items: [{
id: '1_2_1_1',
text: 'HD Video Player',
image: 'images/products/1.png',
price: 240,
}, {
id: '1_2_1_2',
text: 'SuperHD Video Player',
image: 'images/products/2.png',
price: 300,
}],
}, {
id: '1_2_2',
text: 'Televisions',
items: [{
id: '1_2_2_1',
text: 'SuperPlasma 50',
image: 'images/products/3.png',
price: 1800,
}, {
id: '1_2_2_2',
text: 'SuperPlasma 65',
image: 'images/products/8.png',
price: 3500,
}],
}, {
id: '1_2_3',
text: 'Monitors',
items: [{
id: '1_2_3_1',
text: '19"',
items: [{
id: '1_2_3_1_1',
text: 'DesktopLCD 19',
image: 'images/products/10.png',
price: 170,
}],
}, {
id: '1_2_3_2',
text: '21"',
items: [{
id: '1_2_3_2_1',
text: 'DesktopLCD 21',
image: 'images/products/12.png',
price: 180,
}, {
id: '1_2_3_2_2',
text: 'DesktopLED 21',
image: 'images/products/13.png',
price: 190,
}],
}],
}],
}, {
id: '1_3',
text: 'E-Mart',
items: [{
id: '1_3_1',
text: 'Video Players',
items: [{
id: '1_3_1_1',
text: 'HD Video Player',
image: 'images/products/1.png',
price: 220,
}, {
id: '1_3_1_2',
text: 'SuperHD Video Player',
image: 'images/products/2.png',
price: 275,
}],
}, {
id: '1_3_3',
text: 'Monitors',
items: [{
id: '1_3_3_1',
text: '19"',
items: [{
id: '1_3_3_1_1',
text: 'DesktopLCD 19',
image: 'images/products/10.png',
price: 165,
}],
}, {
id: '1_3_3_2',
text: '21"',
items: [{
id: '1_3_3_2_1',
text: 'DesktopLCD 21',
image: 'images/products/12.png',
price: 175,
}],
}],
}],
}, {
id: '1_4',
text: 'Walters',
items: [{
id: '1_4_1',
text: 'Video Players',
items: [{
id: '1_4_1_1',
text: 'HD Video Player',
image: 'images/products/1.png',
price: 210,
}, {
id: '1_4_1_2',
text: 'SuperHD Video Player',
image: 'images/products/2.png',
price: 250,
}],
}, {
id: '1_4_2',
text: 'Televisions',
items: [{
id: '1_4_2_1',
text: 'SuperLCD 42',
image: 'images/products/7.png',
price: 1100,
}, {
id: '1_4_2_2',
text: 'SuperLED 42',
image: 'images/products/5.png',
price: 1400,
}, {
id: '1_4_2_3',
text: 'SuperLED 50',
image: 'images/products/4.png',
price: 1500,
}, {
id: '1_4_2_4',
text: 'SuperLCD 55',
image: 'images/products/6.png',
price: 1300,
}, {
id: '1_4_2_5',
text: 'SuperLCD 70',
image: 'images/products/9.png',
price: 4000,
}, {
id: '1_4_2_6',
text: 'SuperPlasma 50',
image: 'images/products/3.png',
price: 1700,
}],
}, {
id: '1_4_3',
text: 'Monitors',
items: [{
id: '1_4_3_1',
text: '19"',
items: [{
id: '1_4_3_1_1',
text: 'DesktopLCD 19',
image: 'images/products/10.png',
price: 160,
}],
}, {
id: '1_4_3_2',
text: '21"',
items: [{
id: '1_4_3_2_1',
text: 'DesktopLCD 21',
image: 'images/products/12.png',
price: 170,
}, {
id: '1_4_3_2_2',
text: 'DesktopLED 21',
image: 'images/products/13.png',
price: 180,
}],
}],
}, {
id: '1_4_4',
text: 'Projectors',
items: [{
id: '1_4_4_1',
text: 'Projector Plus',
image: 'images/products/14.png',
price: 550,
}, {
id: '1_4_4_2',
text: 'Projector PlusHD',
image: 'images/products/15.png',
price: 750,
}],
}],
}],
}];
export interface ProductType {
id: string,
text: string,
items?: ProductType[],
expanded?: boolean,
image?: string,
price?: number,
}
export default {
getProducts(): ProductType[] {
return products;
},
};
xxxxxxxxxx
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
'bundles:': 'bundles/',
'externals:': 'bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@24.2.5/cjs',
'devextreme-react': 'npm:devextreme-react@24.2.5/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.15/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.59/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
xxxxxxxxxx
const products = [
{
id: '1',
text: 'Stores',
expanded: true,
items: [
{
id: '1_1',
text: 'Super Mart of the West',
expanded: true,
items: [
{
id: '1_1_1',
text: 'Video Players',
items: [
{
id: '1_1_1_1',
text: 'HD Video Player',
price: 220,
image: 'images/products/1.png',
},
{
id: '1_1_1_2',
text: 'SuperHD Video Player',
image: 'images/products/2.png',
price: 270,
},
],
},
{
id: '1_1_2',
text: 'Televisions',
expanded: true,
items: [
{
id: '1_1_2_1',
text: 'SuperLCD 42',
image: 'images/products/7.png',
price: 1200,
},
{
id: '1_1_2_2',
text: 'SuperLED 42',
image: 'images/products/5.png',
price: 1450,
},
{
id: '1_1_2_3',
text: 'SuperLED 50',
image: 'images/products/4.png',
price: 1600,
},
{
id: '1_1_2_4',
text: 'SuperLCD 55',
image: 'images/products/6.png',
price: 1350,
},
{
id: '1_1_2_5',
text: 'SuperLCD 70',
image: 'images/products/9.png',
price: 4000,
},
],
},
{
id: '1_1_3',
text: 'Monitors',
expanded: true,
items: [
{
id: '1_1_3_1',
text: '19"',
expanded: true,
items: [
{
id: '1_1_3_1_1',
text: 'DesktopLCD 19',
image: 'images/products/10.png',
price: 160,
},
],
},
{
id: '1_1_3_2',
text: '21"',
items: [
{
id: '1_1_3_2_1',
text: 'DesktopLCD 21',
image: 'images/products/12.png',
price: 170,
},
{
id: '1_1_3_2_2',
text: 'DesktopLED 21',
image: 'images/products/13.png',
price: 175,
},
],
},
],
},
{
id: '1_1_4',
text: 'Projectors',
items: [
{
id: '1_1_4_1',
text: 'Projector Plus',
image: 'images/products/14.png',
price: 550,
},
{
id: '1_1_4_2',
text: 'Projector PlusHD',
image: 'images/products/15.png',
price: 750,
},
],
},
],
},
{
id: '1_2',
text: 'Braeburn',
items: [
{
id: '1_2_1',
text: 'Video Players',
items: [
{
id: '1_2_1_1',
text: 'HD Video Player',
image: 'images/products/1.png',
price: 240,
},
{
id: '1_2_1_2',
text: 'SuperHD Video Player',
image: 'images/products/2.png',
price: 300,
},
],
},
{
id: '1_2_2',
text: 'Televisions',
items: [
{
id: '1_2_2_1',
text: 'SuperPlasma 50',
image: 'images/products/3.png',
price: 1800,
},
{
id: '1_2_2_2',
text: 'SuperPlasma 65',
image: 'images/products/8.png',
price: 3500,
},
],
},
{
id: '1_2_3',
text: 'Monitors',
items: [
{
id: '1_2_3_1',
text: '19"',
items: [
{
id: '1_2_3_1_1',
text: 'DesktopLCD 19',
image: 'images/products/10.png',
price: 170,
},
],
},
{
id: '1_2_3_2',
text: '21"',
items: [
{
id: '1_2_3_2_1',
text: 'DesktopLCD 21',
image: 'images/products/12.png',
price: 180,
},
{
id: '1_2_3_2_2',
text: 'DesktopLED 21',
image: 'images/products/13.png',
price: 190,
},
],
},
],
},
],
},
{
id: '1_3',
text: 'E-Mart',
items: [
{
id: '1_3_1',
text: 'Video Players',
items: [
{
id: '1_3_1_1',
text: 'HD Video Player',
image: 'images/products/1.png',
price: 220,
},
{
id: '1_3_1_2',
text: 'SuperHD Video Player',
image: 'images/products/2.png',
price: 275,
},
],
},
{
id: '1_3_3',
text: 'Monitors',
items: [
{
id: '1_3_3_1',
text: '19"',
items: [
{
id: '1_3_3_1_1',
text: 'DesktopLCD 19',
image: 'images/products/10.png',
price: 165,
},
],
},
{
id: '1_3_3_2',
text: '21"',
items: [
{
id: '1_3_3_2_1',
text: 'DesktopLCD 21',
image: 'images/products/12.png',
price: 175,
},
],
},
],
},
],
},
{
id: '1_4',
text: 'Walters',
items: [
{
id: '1_4_1',
text: 'Video Players',
items: [
{
id: '1_4_1_1',
text: 'HD Video Player',
image: 'images/products/1.png',
price: 210,
},
{
id: '1_4_1_2',
text: 'SuperHD Video Player',
image: 'images/products/2.png',
price: 250,
},
],
},
{
id: '1_4_2',
text: 'Televisions',
items: [
{
id: '1_4_2_1',
text: 'SuperLCD 42',
image: 'images/products/7.png',
price: 1100,
},
{
id: '1_4_2_2',
text: 'SuperLED 42',
image: 'images/products/5.png',
price: 1400,
},
{
id: '1_4_2_3',
text: 'SuperLED 50',
image: 'images/products/4.png',
price: 1500,
},
{
id: '1_4_2_4',
text: 'SuperLCD 55',
image: 'images/products/6.png',
price: 1300,
},
{
id: '1_4_2_5',
text: 'SuperLCD 70',
image: 'images/products/9.png',
price: 4000,
},
{
id: '1_4_2_6',
text: 'SuperPlasma 50',
image: 'images/products/3.png',
price: 1700,
},
],
},
{
id: '1_4_3',
text: 'Monitors',
items: [
{
id: '1_4_3_1',
text: '19"',
items: [
{
id: '1_4_3_1_1',
text: 'DesktopLCD 19',
image: 'images/products/10.png',
price: 160,
},
],
},
{
id: '1_4_3_2',
text: '21"',
items: [
{
id: '1_4_3_2_1',
text: 'DesktopLCD 21',
image: 'images/products/12.png',
price: 170,
},
{
id: '1_4_3_2_2',
text: 'DesktopLED 21',
image: 'images/products/13.png',
price: 180,
},
],
},
],
},
{
id: '1_4_4',
text: 'Projectors',
items: [
{
id: '1_4_4_1',
text: 'Projector Plus',
image: 'images/products/14.png',
price: 550,
},
{
id: '1_4_4_2',
text: 'Projector PlusHD',
image: 'images/products/15.png',
price: 750,
},
],
},
],
},
],
},
];
export default {
getProducts() {
return products;
},
};
xxxxxxxxxx
<html lang="en">
<head></head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
xxxxxxxxxx
#simple-treeview,
#product-details {
display: inline-block;
}
#product-details {
vertical-align: top;
width: 400px;
height: 420px;
margin-left: 20px;
}
#product-details > img {
border: none;
height: 300px;
width: 400px;
}
#product-details > .name {
text-align: center;
font-size: 20px;
}
#product-details > .price {
text-align: center;
font-size: 24px;
}
.dark #product-details > div {
color: #f0f0f0;
}
.hidden {
visibility: hidden;
}
Each object in the TreeView's hierarchical data structure should include the following fields:
You can respectively use the keyExpr, displayExpr, and itemsExpr properties to specify custom names for the above-mentioned fields. Node objects can also include developer-defined fields and properties from this help section: items[].
In this demo, nodes use the expanded property, which specifies whether a node is collapsed or expanded. They also include the developer-defined price
and image
fields.
To get started with the DevExtreme TreeView component, refer to the following tutorial for step-by-step instructions: Getting Started with TreeView.

<div class="form">
<dx-tree-view
id="simple-treeview"
[items]="products"
[width]="300"
(onItemClick)="selectItem($event)"
></dx-tree-view>
<div id="product-details" *ngIf="currentItem.price">
<img [src]="currentItem.image" />
<div class="name">{{ currentItem.text }}</div>
<div class="price">{{ "$" + currentItem.price }}</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxTreeViewModule, DxTreeViewTypes } from 'devextreme-angular/ui/tree-view';
import { Product, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxTreeViewModule,
],
})
export class AppComponent {
products: Product[];
currentItem: Product;
constructor(service: Service) {
this.products = service.getProducts();
this.currentItem = this.products[0];
}
selectItem(e: DxTreeViewTypes.ItemClickEvent<Product>) {
this.currentItem = e.itemData;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #simple-treeview,
#product-details {
display: inline-block;
}
::ng-deep #product-details {
vertical-align: top;
width: 400px;
height: 420px;
margin-left: 20px;
}
::ng-deep #product-details > img {
border: none;
height: 300px;
width: 400px;
}
::ng-deep #product-details > .name {
text-align: center;
font-size: 20px;
}
::ng-deep #product-details > .price {
text-align: center;
font-size: 24px;
}
::ng-deep .dark #product-details > div {
color: #f0f0f0;
}
::ng-deep .hidden {
visibility: hidden;
}
import { Injectable } from '@angular/core';
export class Product {
id: string;
text: string;
expanded?: boolean;
items?: Product[];
price?: number;
image?: string;
}
const products: Product[] = [{
id: '1',
text: 'Stores',
expanded: true,
items: [{
id: '1_1',
text: 'Super Mart of the West',
expanded: true,
items: [{
id: '1_1_1',
text: 'Video Players',
items: [{
id: '1_1_1_1',
text: 'HD Video Player',
price: 220,
image: '../../../../images/products/1.png',
}, {
id: '1_1_1_2',
text: 'SuperHD Video Player',
image: '../../../../images/products/2.png',
price: 270,
}],
}, {
id: '1_1_2',
text: 'Televisions',
expanded: true,
items: [{
id: '1_1_2_1',
text: 'SuperLCD 42',
image: '../../../../images/products/7.png',
price: 1200,
}, {
id: '1_1_2_2',
text: 'SuperLED 42',
image: '../../../../images/products/5.png',
price: 1450,
}, {
id: '1_1_2_3',
text: 'SuperLED 50',
image: '../../../../images/products/4.png',
price: 1600,
}, {
id: '1_1_2_4',
text: 'SuperLCD 55',
image: '../../../../images/products/6.png',
price: 1350,
}, {
id: '1_1_2_5',
text: 'SuperLCD 70',
image: '../../../../images/products/9.png',
price: 4000,
}],
}, {
id: '1_1_3',
text: 'Monitors',
expanded: true,
items: [{
id: '1_1_3_1',
text: '19"',
expanded: true,
items: [{
id: '1_1_3_1_1',
text: 'DesktopLCD 19',
image: '../../../../images/products/10.png',
price: 160,
}],
}, {
id: '1_1_3_2',
text: '21"',
items: [{
id: '1_1_3_2_1',
text: 'DesktopLCD 21',
image: '../../../../images/products/12.png',
price: 170,
}, {
id: '1_1_3_2_2',
text: 'DesktopLED 21',
image: '../../../../images/products/13.png',
price: 175,
}],
}],
}, {
id: '1_1_4',
text: 'Projectors',
items: [{
id: '1_1_4_1',
text: 'Projector Plus',
image: '../../../../images/products/14.png',
price: 550,
}, {
id: '1_1_4_2',
text: 'Projector PlusHD',
image: '../../../../images/products/15.png',
price: 750,
}],
}],
}, {
id: '1_2',
text: 'Braeburn',
items: [{
id: '1_2_1',
text: 'Video Players',
items: [{
id: '1_2_1_1',
text: 'HD Video Player',
image: '../../../../images/products/1.png',
price: 240,
}, {
id: '1_2_1_2',
text: 'SuperHD Video Player',
image: '../../../../images/products/2.png',
price: 300,
}],
}, {
id: '1_2_2',
text: 'Televisions',
items: [{
id: '1_2_2_1',
text: 'SuperPlasma 50',
image: '../../../../images/products/3.png',
price: 1800,
}, {
id: '1_2_2_2',
text: 'SuperPlasma 65',
image: '../../../../images/products/8.png',
price: 3500,
}],
}, {
id: '1_2_3',
text: 'Monitors',
items: [{
id: '1_2_3_1',
text: '19"',
items: [{
id: '1_2_3_1_1',
text: 'DesktopLCD 19',
image: '../../../../images/products/10.png',
price: 170,
}],
}, {
id: '1_2_3_2',
text: '21"',
items: [{
id: '1_2_3_2_1',
text: 'DesktopLCD 21',
image: '../../../../images/products/12.png',
price: 180,
}, {
id: '1_2_3_2_2',
text: 'DesktopLED 21',
image: '../../../../images/products/13.png',
price: 190,
}],
}],
}],
}, {
id: '1_3',
text: 'E-Mart',
items: [{
id: '1_3_1',
text: 'Video Players',
items: [{
id: '1_3_1_1',
text: 'HD Video Player',
image: '../../../../images/products/1.png',
price: 220,
}, {
id: '1_3_1_2',
text: 'SuperHD Video Player',
image: '../../../../images/products/2.png',
price: 275,
}],
}, {
id: '1_3_3',
text: 'Monitors',
items: [{
id: '1_3_3_1',
text: '19"',
items: [{
id: '1_3_3_1_1',
text: 'DesktopLCD 19',
image: '../../../../images/products/10.png',
price: 165,
}],
}, {
id: '1_3_3_2',
text: '21"',
items: [{
id: '1_3_3_2_1',
text: 'DesktopLCD 21',
image: '../../../../images/products/12.png',
price: 175,
}],
}],
}],
}, {
id: '1_4',
text: 'Walters',
items: [{
id: '1_4_1',
text: 'Video Players',
items: [{
id: '1_4_1_1',
text: 'HD Video Player',
image: '../../../../images/products/1.png',
price: 210,
}, {
id: '1_4_1_2',
text: 'SuperHD Video Player',
image: '../../../../images/products/2.png',
price: 250,
}],
}, {
id: '1_4_2',
text: 'Televisions',
items: [{
id: '1_4_2_1',
text: 'SuperLCD 42',
image: '../../../../images/products/7.png',
price: 1100,
}, {
id: '1_4_2_2',
text: 'SuperLED 42',
image: '../../../../images/products/5.png',
price: 1400,
}, {
id: '1_4_2_3',
text: 'SuperLED 50',
image: '../../../../images/products/4.png',
price: 1500,
}, {
id: '1_4_2_4',
text: 'SuperLCD 55',
image: '../../../../images/products/6.png',
price: 1300,
}, {
id: '1_4_2_5',
text: 'SuperLCD 70',
image: '../../../../images/products/9.png',
price: 4000,
}, {
id: '1_4_2_6',
text: 'SuperPlasma 50',
image: '../../../../images/products/3.png',
price: 1700,
}],
}, {
id: '1_4_3',
text: 'Monitors',
items: [{
id: '1_4_3_1',
text: '19"',
items: [{
id: '1_4_3_1_1',
text: 'DesktopLCD 19',
image: '../../../../images/products/10.png',
price: 160,
}],
}, {
id: '1_4_3_2',
text: '21"',
items: [{
id: '1_4_3_2_1',
text: 'DesktopLCD 21',
image: '../../../../images/products/12.png',
price: 170,
}, {
id: '1_4_3_2_2',
text: 'DesktopLED 21',
image: '../../../../images/products/13.png',
price: 180,
}],
}],
}, {
id: '1_4_4',
text: 'Projectors',
items: [{
id: '1_4_4_1',
text: 'Projector Plus',
image: '../../../../images/products/14.png',
price: 550,
}, {
id: '1_4_4_2',
text: 'Projector PlusHD',
image: '../../../../images/products/15.png',
price: 750,
}],
}],
}],
}];
@Injectable()
export class Service {
getProducts(): Product[] {
return products;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.25/package.json',
'npm:devexpress-gantt@4.1.67/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.0.7"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Hierarchical Data Structure

Use the following properties to bind the TreeView to hierarchical data:

  • items[]
    Assigns a local array as done in this demo.

  • dataSource
    Assigns a DataSource object that allows you to perform data shaping operations and use a remote source.

Each object in the TreeView's hierarchical data structure should include the following fields:

  • id
    Unique item identifier.

  • text
    Text displayed by the item.

  • items
    Nested objects (optional).

You can respectively use the keyExpr, displayExpr, and itemsExpr properties to specify custom names for the above-mentioned fields. Node objects can also include developer-defined fields and properties from this help section: items[].

In this demo, nodes use the expanded property, which specifies whether a node is collapsed or expanded. They also include the developer-defined price and image fields.

To get started with the DevExtreme TreeView component, refer to the following tutorial for step-by-step instructions: Getting Started with TreeView.

Backend API
<template> <div class="form"> <DxTreeView id="simple-treeview" :items="products" :width="300" @item-click="selectItem" /> <div v-if="currentItem.price" id="product-details" > <img :src="currentItem.image"> <div class="name">{{ currentItem.text }}</div> <div class="price">{{ "$" + currentItem.price }}</div> </div> </div> </template> <script setup lang="ts"> import { ref } from 'vue'; import DxTreeView from 'devextreme-vue/tree-view'; import service from './data.ts'; const products = service.getProducts(); const currentItem = ref(products[0]); function selectItem({ itemData }) { currentItem.value = itemData; } </script> <style scoped> #simple-treeview, #product-details { display: inline-block; } #product-details { vertical-align: top; width: 400px; height: 420px; margin-left: 20px; } #product-details > img { border: none; height: 300px; width: 400px; } #product-details > .name { text-align: center; font-size: 20px; } #product-details > .price { text-align: center; font-size: 24px; } .dark #product-details > div { color: #f0f0f0; } .hidden { visibility: hidden; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'root:': '../../../../../', 'npm:': 'https://unpkg.com/', }, map: { 'vue': 'npm:vue@3.3.4/dist/vue.esm-browser.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js', 'demo-ts-loader': 'root:utils/demo-ts-loader.js', 'svg-loader': 'root:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.2.6/cjs', 'devextreme-vue': 'npm:devextreme-vue@23.2.6/cjs', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.5/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.54/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.12/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; System.config(window.config);
const products = [{ id: '1', text: 'Stores', expanded: true, items: [{ id: '1_1', text: 'Super Mart of the West', expanded: true, items: [{ id: '1_1_1', text: 'Video Players', items: [{ id: '1_1_1_1', text: 'HD Video Player', price: 220, image: '../../../../images/products/1.png', }, { id: '1_1_1_2', text: 'SuperHD Video Player', image: '../../../../images/products/2.png', price: 270, }], }, { id: '1_1_2', text: 'Televisions', expanded: true, items: [{ id: '1_1_2_1', text: 'SuperLCD 42', image: '../../../../images/products/7.png', price: 1200, }, { id: '1_1_2_2', text: 'SuperLED 42', image: '../../../../images/products/5.png', price: 1450, }, { id: '1_1_2_3', text: 'SuperLED 50', image: '../../../../images/products/4.png', price: 1600, }, { id: '1_1_2_4', text: 'SuperLCD 55', image: '../../../../images/products/6.png', price: 1350, }, { id: '1_1_2_5', text: 'SuperLCD 70', image: '../../../../images/products/9.png', price: 4000, }], }, { id: '1_1_3', text: 'Monitors', expanded: true, items: [{ id: '1_1_3_1', text: '19"', expanded: true, items: [{ id: '1_1_3_1_1', text: 'DesktopLCD 19', image: '../../../../images/products/10.png', price: 160, }], }, { id: '1_1_3_2', text: '21"', items: [{ id: '1_1_3_2_1', text: 'DesktopLCD 21', image: '../../../../images/products/12.png', price: 170, }, { id: '1_1_3_2_2', text: 'DesktopLED 21', image: '../../../../images/products/13.png', price: 175, }], }], }, { id: '1_1_4', text: 'Projectors', items: [{ id: '1_1_4_1', text: 'Projector Plus', image: '../../../../images/products/14.png', price: 550, }, { id: '1_1_4_2', text: 'Projector PlusHD', image: '../../../../images/products/15.png', price: 750, }], }], }, { id: '1_2', text: 'Braeburn', items: [{ id: '1_2_1', text: 'Video Players', items: [{ id: '1_2_1_1', text: 'HD Video Player', image: '../../../../images/products/1.png', price: 240, }, { id: '1_2_1_2', text: 'SuperHD Video Player', image: '../../../../images/products/2.png', price: 300, }], }, { id: '1_2_2', text: 'Televisions', items: [{ id: '1_2_2_1', text: 'SuperPlasma 50', image: '../../../../images/products/3.png', price: 1800, }, { id: '1_2_2_2', text: 'SuperPlasma 65', image: '../../../../images/products/8.png', price: 3500, }], }, { id: '1_2_3', text: 'Monitors', items: [{ id: '1_2_3_1', text: '19"', items: [{ id: '1_2_3_1_1', text: 'DesktopLCD 19', image: '../../../../images/products/10.png', price: 170, }], }, { id: '1_2_3_2', text: '21"', items: [{ id: '1_2_3_2_1', text: 'DesktopLCD 21', image: '../../../../images/products/12.png', price: 180, }, { id: '1_2_3_2_2', text: 'DesktopLED 21', image: '../../../../images/products/13.png', price: 190, }], }], }], }, { id: '1_3', text: 'E-Mart', items: [{ id: '1_3_1', text: 'Video Players', items: [{ id: '1_3_1_1', text: 'HD Video Player', image: '../../../../images/products/1.png', price: 220, }, { id: '1_3_1_2', text: 'SuperHD Video Player', image: '../../../../images/products/2.png', price: 275, }], }, { id: '1_3_3', text: 'Monitors', items: [{ id: '1_3_3_1', text: '19"', items: [{ id: '1_3_3_1_1', text: 'DesktopLCD 19', image: '../../../../images/products/10.png', price: 165, }], }, { id: '1_3_3_2', text: '21"', items: [{ id: '1_3_3_2_1', text: 'DesktopLCD 21', image: '../../../../images/products/12.png', price: 175, }], }], }], }, { id: '1_4', text: 'Walters', items: [{ id: '1_4_1', text: 'Video Players', items: [{ id: '1_4_1_1', text: 'HD Video Player', image: '../../../../images/products/1.png', price: 210, }, { id: '1_4_1_2', text: 'SuperHD Video Player', image: '../../../../images/products/2.png', price: 250, }], }, { id: '1_4_2', text: 'Televisions', items: [{ id: '1_4_2_1', text: 'SuperLCD 42', image: '../../../../images/products/7.png', price: 1100, }, { id: '1_4_2_2', text: 'SuperLED 42', image: '../../../../images/products/5.png', price: 1400, }, { id: '1_4_2_3', text: 'SuperLED 50', image: '../../../../images/products/4.png', price: 1500, }, { id: '1_4_2_4', text: 'SuperLCD 55', image: '../../../../images/products/6.png', price: 1300, }, { id: '1_4_2_5', text: 'SuperLCD 70', image: '../../../../images/products/9.png', price: 4000, }, { id: '1_4_2_6', text: 'SuperPlasma 50', image: '../../../../images/products/3.png', price: 1700, }], }, { id: '1_4_3', text: 'Monitors', items: [{ id: '1_4_3_1', text: '19"', items: [{ id: '1_4_3_1_1', text: 'DesktopLCD 19', image: '../../../../images/products/10.png', price: 160, }], }, { id: '1_4_3_2', text: '21"', items: [{ id: '1_4_3_2_1', text: 'DesktopLCD 21', image: '../../../../images/products/12.png', price: 170, }, { id: '1_4_3_2_2', text: 'DesktopLED 21', image: '../../../../images/products/13.png', price: 180, }], }], }, { id: '1_4_4', text: 'Projectors', items: [{ id: '1_4_4_1', text: 'Projector Plus', image: '../../../../images/products/14.png', price: 550, }, { id: '1_4_4_2', text: 'Projector PlusHD', image: '../../../../images/products/15.png', price: 750, }], }], }], }]; export default { getProducts() { return products; }, };
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.6/css/dx.light.css" /> <script src="https://unpkg.com/typescript@4.2.4/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://unpkg.com/@vue/compiler-sfc@3.3.4/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>